<template>
	<f7-page name="contact" @page:beforein="onPageBeforeIn">
		<!-- Top Navbar -->
		<f7-navbar :sliding="false">
			<f7-nav-left back-link>
            </f7-nav-left>
            <f7-nav-title class="show-small-title">No. Telp Penting</f7-nav-title>
            <f7-subnavbar :inner="false">
                <f7-searchbar :init="false" placeholder="Cari" class="searchbar"></f7-searchbar>
            </f7-subnavbar>
		</f7-navbar>

		<!-- Page content-->
        <f7-list class="searchbar-not-found">
            <f7-list-item title="Tidak ada data yang ditemukan"></f7-list-item>
        </f7-list>
        <f7-list contacts-list v-if="contactList.length > 0" class="search-list searchbar-found">
            <f7-list-group v-for="item in contactList" v-bind:key="item.group">
                <f7-list-item :title="item.group" group-title></f7-list-item>
                <f7-list-item @click="showActionSheet(child)" v-for="child in item.children" v-bind:key="child.id" :title="child.title"></f7-list-item>
            </f7-list-group>            
        </f7-list>
    </f7-page>
</template>
<script>
import { mapGetters } from 'vuex';
import { setTimeout } from 'timers';
export default {
    name: 'Contact',
    data(){
        return{
            contactList: []
        }
    },
    computed: {
        ...mapGetters('auth', ['user']),
        ...mapGetters('contact', ['contacts'])
    },
    mounted(){

        const self = this;
		const app = self.$f7;

        setTimeout(()=>{
            var searchbar = app.searchbar.create({
                el: '.searchbar',
                placeholder: 'Cari',
                searchContainer: '.search-list',
                searchIn: '.item-title',
                disableButton: false
            });
        }, 1000)
    },
    methods: {
        onPageBeforeIn(){
            const self = this;
			const app = self.$f7;
			const $$ = self.$$;
            const $el = $$(self.$el);
            
            app.preloader.show('green');

            self.$store.dispatch('contact/getContacts',{
                only: 'id,title,fullname,description,email,phone,alt_phone,address,latitude,longitude'
            }).then((response) => {
                let data = self.contacts.reduce((r, e) => {
                    let group = e.title[0];
                    if(!r[group]) r[group] = {group, children: [e]}
                    else r[group].children.push(e);
                    return r;
                }, {});

                self.contactList = Object.values(data);

                app.preloader.hide();
            });
        },
        showActionSheet(contact){
            const self = this;
            const app = self.$f7;

            let buttons = [{
                text: 'Hubungi ' + contact.title,
                label: true
            }];

            buttons.push({
                text: contact.phone,
                close: true,
                onClick: function(actions, e){
                    location.href = "tel:"+contact.phone.replace('0','+62');
                }
            });

            if(contact.alt_phone != null){
                buttons[0].push({
                    text: contact.alt_phone,
                    close: true,
                    onClick: function(actions, e){
                        location.href = "tel:"+contact.alt_phone.replace('0','+62');
                    }
                });
            }

            buttons.push({
                text: 'Batal',
                color: 'red',
                close: true
            });

            let actionSheet = app.actions.create({
                buttons: buttons
            }).open();
        }
    }
}
</script>
